Subject: [PATCH iproute2 0/5] Teach ss to show sockets' shutdown state

From: Pavel Emelyanov <[email-masked]>
Date: Thu, 25 Oct 2012 17:16:31 +0400

In the net-next sits a patch which extends the sock-diag subsys to 
show the sockets' shutdown state. I propose to teach the ss tool to 
print this info when requested with -e|--extended key.

The output will look like arrows at the end of each line, like this:

ESTAB 0 0  127.0.0.1:41705  127.0.0.1:12345  ino:143321 sk:ffff88003a8cea00 -->
ESTAB 0 0  127.0.0.1:46925  127.0.0.1:12346  ino:143322 sk:ffff88003a8ce4c0 <--
ESTAB 0 0  127.0.0.1:51678  127.0.0.1:12347  ino:143323 sk:ffff88003a8cdf80 ---
ESTAB 0 0  127.0.0.1:46911  127.0.0.1:12348  ino:143324 sk:ffff88003b7f05c0 <->

for SHUT_RD, SHUT_WR, SHUT_RDWR and non-shutdown sockets respectively.

In order to do so, it's also required to implement support for the
newer sock-diag in tcp and udp netlink code. I did it before, but
broke compatibility with older kernels (those without sock-diag).
Now this is fixed (checked on 2.6.40 kernel).

Signed-off-by: Pavel Emelyanov <[email-masked]>